
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>
#include <stdlib.h>
#include "penta.h"


/* $BE($,%Z%sB@$rC5$7%Z%sB@$N$$$kJ}8~$rJV$94X?t(B */
int search_pen(pen,teki)
PENTA *pen; /* $B$Z$s$?$N9=B$BN(B */
TEKI *teki; /* $BE($N9=B$BN(B */
{
    int px,py,tx,ty;
    int shirei;

    /* printf("search_pen\n"); */
    px = pen->pen_x;
    py = pen->pen_y;
    tx = teki->teki_x;
    ty = teki->teki_y;
    if ( px < tx ) shirei = 4;
    if ( py < ty ) shirei = 8;
    if ( py > ty ) shirei = 2; 
    if ( px > tx ) shirei = 6;   
    if ( (py < ty) && (px < tx) ) shirei = 7;  
    if ( (py > ty) && (px < tx) ) shirei = 1;
    if ( (py > ty) && (px > tx) ) shirei = 3;
    if ( (px > tx) && (py < ty) ) shirei = 9;

    /* printf("shirei = %d\n",shirei); */

    return(shirei);
}

/* $B;XDj$5$l$?J*BN$H@\?($7$F$$$k$+$rD4$Y$k4X?t(B */
int search_obj(tx,ty,obj)
int tx,ty;
OBJECT *obj;
{
    int ox,oy,ow,oh;

    ox = obj->obj_x;
    oy = obj->obj_y;
    ow = p_width;
    oh = p_height;

    if ( check(tx,ty,50,50,ox,oy,ow,oh) == 1 )
	return(1);
    else
	return(0);
}


/* $BE($N%"%k%4%j%:%`(B */
TEKI *algo(teki,top,pen,obj)
TEKI *teki;
TEKI *top;
PENTA *pen;
OBJECT *obj;
{
    OBJECT *o;
    TEKI *t;
   

    int move; 
    int point;
    int up,down,right,left;
    int tx,ty,tw,th;

   
    o = obj;
    t = teki;
    move = t->move; 
    point = t->point; 
    

    up = down = left = right = 0;   /* $B=i4|2=(B */
    tx = t->teki_x;
    ty = t->teki_y;
    tw = p_width;
    th = p_height;

    switch(search_pen(pen,t)) {
      case 1:
	down = down + point;
	left = left + point;
	break;
      case 2:
	down = down + point;
	break;
      case 3:
	down = down + point;
	right = right + point;
	break;
      case 4:
	left = left + point;
	break;
      case 6:
	right = right + point;
	break;
      case 7:
	left = left + point;
	up = up + point;
	break;
      case 8:
	up = up + point;
	break;
      case 9:
	up = up + point;
	right = right + point;
	break;
    }

    switch(t->muki) {
      case 1:
	up = up + point - 1;
	down = down + - point;
	break;
      case 2:
	left = left + point - 1;
	right = right - point;
	break;
      case 3:
	down = down + point - 1;
	up = up - point;
	break;
      case 4:
	right = right + point - 1;
	left = left - point;
	break;
    }

    /* $BE(F1;N$N=E$J$j$rD4$Y$k(B */

    if ( check_teki_teki(tx,ty - move,t,top) == 1 )
	up = 0;
    if ( check_teki_teki(tx - move,ty,t,top) == 1 )
	left = 0;
    if ( check_teki_teki(tx,ty + move,t,top) == 1 )
	down = 0;
    if ( check_teki_teki(tx + move,ty,t,top) == 1 )
	right = 0;

    /* $BJ*BN$H$N@\?($rD4$Y$k(B */
    while  ( obj != NULL ) {
	if ( search_obj(tx,ty - move,obj) == 1 ) {
	    up = 0;
	    t->muki = 1;
	}
	if ( search_obj(tx - move,ty,obj) == 1 ) {
	    left = 0;
	    t->muki = 2;
	}
	if ( search_obj(tx,ty + move,obj) == 1 ) {
	    down = 0;
	    t->muki = 3;
	}
	if ( search_obj(tx + move,ty,obj) == 1 ) {
	    right = 0;
	    t->muki = 4;
	}
	obj = obj->next;

    }

    /* $B<B:]$N0\F0(B */
    if ( (up > down) && (up > left) && (up > right) ) {
	t->teki_y = t->teki_y - move;
	t->muki = 1;
	/* printf("up\n"); */
    }
    if ( (left > up) && (left > down) && (left > right) ) {
	t->teki_x = t->teki_x - move;
	t->muki = 2;
	/* printf("left\n"); */
    }
    if ( (down > up) && (down > left) && (down > right) ) {
	t->teki_y = t->teki_y + move;
	t->muki = 3;
	/* printf("down\n"); */
    }
    if ( (right > up) && (right > left) && (right > down) ) {
	t->teki_x = t->teki_x + move;
	t->muki =4;
	/* printf("right\n"); */
    }
  
    /* $B%9%?%$%k$N=$@5(B */
    switch(t->style) {
    case 1:
      t->style = 2;
      break;
    case 2:
      t->style = 1;
      break;
     
    }
   
    if ( up <= 0 && left <= 0 && down <= 0 && right <= 0 )
      t->muki = 0;

    
    /*
       $B%F%9%HMQ(B
       printf("muki = %d \n",t->muki);
       printf("style = %d \n",t->style);
       printf("up %d left %d down %d right %d \n",up,left,down,right);
       printf("algo_main end \n");
       */

    return (t);
  }






